connect "crossroad:c:\db\b2_3.gdb" USER "CREATOR" password "67";

declare external function udfIntruder_Create
  returns
   integer by value
   entry_point "udfIntruder_Create"
   module_name "ISCdispatcher";


declare external function udfIntruder_Terminate
  returns
   integer by value
   entry_point "udfIntruder_Terminate"
   module_name "ISCdispatcher";


declare external function udfIntruder_Resume
  returns
   integer by value
   entry_point "udfIntruder_Resume"
   module_name "ISCdispatcher";

declare external function udfIntruder_Suspend
  returns
   integer by value
   entry_point "udfIntruder_Suspend"
   module_name "ISCdispatcher";

declare external function udfIntruder_SetReabilitatnLevel
   double precision
  returns
   double precision by value
  entry_point "udfIntruder_SetReabilitatnLevel"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetReabilitatnLevel
  returns
   double precision by value
  entry_point "udfIntruder_GetReabilitatnLevel"
  module_name "ISCdispatcher";


declare external function udfIntruder_SetBadLevel
   double precision
  returns
   double precision by value
  entry_point "udfIntruder_SetBadLevel"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetBadLevel
  returns
   double precision by value
  entry_point "udfIntruder_GetBadLevel"
  module_name "ISCdispatcher";



declare external function udfIntruder_GetCurrentState
  returns
   smallint by value
  entry_point "udfIntruder_GetCurrentState"
  module_name "ISCdispatcher";


declare external function udfIntruder_SetMeasuringPeriod
   integer
  returns
   integer by value
  entry_point "udfIntruder_SetMeasuringPeriod"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetMeasuringPeriod
  returns
   integer by value
  entry_point "udfIntruder_GetMeasuringPeriod"
  module_name "ISCdispatcher";


declare external function udfIntruder_SetReabilitatPeriod
   integer
  returns
   integer by value
  entry_point "udfIntruder_SetReabilitatPeriod"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetReabilitatPeriod
  returns
   integer by value
  entry_point "udfIntruder_GetReabilitatPeriod"
  module_name "ISCdispatcher";



declare external function udfIntruder_SetPoorPeriod
   integer
  returns
   integer by value
  entry_point "udfIntruder_SetPoorPeriod"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetPoorPeriod
  returns
   integer by value
  entry_point "udfIntruder_GetPoorPeriod"
  module_name "ISCdispatcher";


declare external function udfIntruder_SetBadPeriod
   integer
  returns
   integer by value
  entry_point "udfIntruder_SetBadPeriod"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetBadPeriod
  returns
   integer by value
  entry_point "udfIntruder_GetBadPeriod"
  module_name "ISCdispatcher";


declare external function udfIntruder_SetRoughPeriod
   integer
  returns
   integer by value
  entry_point "udfIntruder_SetRoughPeriod"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetRoughPeriod
  returns
   integer by value
  entry_point "udfIntruder_GetRoughPeriod"
  module_name "ISCdispatcher";


declare external function udfIntruder_SetRoughMode
   smallint
  returns
   smallint by value
  entry_point "udfIntruder_SetRoughMode"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetRoughMode
  returns
   smallint by value
  entry_point "udfIntruder_GetRoughMode"
  module_name "ISCdispatcher";



declare external function udfIntruder_GetPoorPeriodCount
  returns
   integer by value
  entry_point "udfIntruder_GetPoorPeriodCount"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetBadPeriodCount
  returns
   integer by value
  entry_point "udfIntruder_GetBadPeriodCount"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetRoughPeriodCount
  returns
   integer by value
  entry_point "udfIntruder_GetRoughPeriodCount"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetAverageCPUusage
  returns
   double precision by value
  entry_point "udfIntruder_GetAverageCPUusage"
  module_name "ISCdispatcher";

declare external function udfIntruder_GetAverageCPUusageM
  returns
   double precision by value
  entry_point "udfIntruder_GetAverageCPUusageM"
  module_name "ISCdispatcher";


commit;



set term ^ ;

create procedure eprIntruder_Create
returns
(
MainThreadID integer
)
as
begin
 MainThreadID = udfIntruder_Create ();
end
^
commit^

create procedure eprIntruder_Terminate
returns
(
Result integer
)
as
begin
 Result = udfIntruder_Terminate ();
end
^
commit^

create procedure eprIntruder_Resume
returns
(
Result integer
)
as
begin
 Result = udfIntruder_Resume ();
end
^
commit^

create procedure eprIntruder_Suspend
returns
(
Result integer
)
as
begin
 Result = udfIntruder_Suspend ();
end
^
commit^

create procedure eprIntruder_SetLevels
(
ReabilitationLevel double precision,
BadLevel double precision
)
returns
(
ResReabilitationLevel double precision,
ResBadLevel double precision
)
as
begin
 ResReabilitationLevel = udfIntruder_SetReabilitatnLevel (:ReabilitationLevel);
 ResBadLevel = udfIntruder_SetBadLevel (:BadLevel);
end
^
commit^

create procedure eprIntruder_SetPeriods
(
MeasuringPeriod integer,
ReabilitatPeriod integer,
PoorPeriod integer,
BadPeriod integer,
RoughPeriod integer
)
returns
(
ResMeasuringPeriod integer,
ResReabilitatPeriod integer,
ResPoorPeriod integer,
ResBadPeriod integer,
ResRoughPeriod integer

)
as
begin
 ResMeasuringPeriod  = udfIntruder_SetMeasuringPeriod (:MeasuringPeriod);
 ResReabilitatPeriod = udfIntruder_SetReabilitatPeriod (:ReabilitatPeriod);
 ResPoorPeriod       = udfIntruder_SetPoorPeriod (:PoorPeriod);
 ResBadPeriod        = udfIntruder_SetBadPeriod (:BadPeriod);
 ResRoughPeriod      = udfIntruder_SetRoughPeriod (:RoughPeriod);
end
^
commit^


create procedure eprIntruder_GetProps
returns
(
ReabilitationLevel double precision,
BadLevel double precision,
MeasuringPeriod integer,
ReabilitatPeriod integer,
PoorPeriod integer,
BadPeriod integer,
RoughPeriod integer,
CurrentState smallint,
RoughMode  smallint,
PoorPeriodCount integer,
BadPeriodCount  integer,
RoughPeriodCount integer,
AverageCPUusage  double precision,
AverageCPUusageMax double precision
)
as
begin
 CurrentState     = udfIntruder_GetCurrentState ();
 PoorPeriodCount  = udfIntruder_GetPoorPeriodCount ();
 BadPeriodCount   = udfIntruder_GetBadPeriodCount ();
 RoughPeriodCount = udfIntruder_GetRoughPeriodCount ();
 AverageCPUusage  = udfIntruder_GetAverageCPUusage ();
 AverageCPUusageMax = udfIntruder_GetAverageCPUusageM ();
 MeasuringPeriod  = udfIntruder_GetMeasuringPeriod ();
 ReabilitatPeriod = udfIntruder_GetReabilitatPeriod ();
 PoorPeriod       = udfIntruder_GetPoorPeriod ();
 BadPeriod        = udfIntruder_GetBadPeriod ();
 RoughPeriod      = udfIntruder_GetRoughPeriod ();
 ReabilitationLevel = udfIntruder_GetReabilitatnLevel ();
 BadLevel         = udfIntruder_GetBadLevel ();
 RoughMode        = udfIntruder_GetRoughMode ();
end
^
commit^

create procedure eprIntruder_SetRoughMode
(
RoughMode smallint
)
returns
(
ResRoughMode smallint
)
as
begin
 ResRoughMode = udfIntruder_SetRoughMode (:RoughMode);
end
^
commit^



set term ; ^

commit;

